/* Prototypes.h */

/* file.c */

short WriteEOF(void);												/* write end of file block */
short WriteFile(Str255);											/* write a file to tape */
short ReadFile(void);												/* read a file from tape */
short ListFile(void);												/* list a file from tape */
long Checksum(void *, long);										/* calculate checksum */

/* main.c */

void main(void);
void ToolBoxInit(void);												/* initialise Mac toolbox */
void AdjustMenus(void);												/* adjust menus */
void HandleAppleChoice(short);										/* selection in apple menu */
void HandleEditChoice(short);										/* selection in edit menu */
void HandleFileChoice(short);										/* selection in file menu */
void HandleMenuChoice(long);										/* menu selection */
void HandleMouseDown(void);											/* mouse down */
short IsDAWindow(WindowPtr);										/* check for DA's */
void MainLoop(void);												/* main event loop */
void MenuBarInit(void);												/* put in new menu bar */

/* work.c */

void DoWork(short);													/* do the actual work */
short SearchDirectory(long parID, short vRefNum, 					/* recursively search directory */
	short (*fileFunc)(Str255), short (*dirFunc)(Str255));
void Initialize(void);												/* non-toolbox initialize */

/* StandardGetFolder.c */

void StandardGetFolder (Str255 message, StandardFileReply *mySFReply);

/* FullFileName.c */

short FullFileName(StringPtr outname, StringPtr tail, short volume, long dirID);	/* vol & dirID to pathname */

/* buffer.c */

BUFFER *BufferOpen(void);											/* open for buffered io */
short BufferRead(BUFFER *ptr, char *data, long count);				/* buffered read */
short BufferWrite(BUFFER *ptr, char *data, long count);				/* buffered write */
void BufferClose(BUFFER *ptr);										/* close buffer */
