/* SCSIDefines.h */

/* SCSI stuff */

#define SENSE_BYTES 	4					/* number of bytes in sense reply */
#define BLOCKSIZE 		512					/* block size */
#define TIMEOUT 		18000				/* command timeout (ticks) */

#define UNIT_READY 		0x00
#define REWIND 			0x01
#define REQUEST_SENSE 	0x03				
#define READ 			0x08
#define WRITE 			0x0a
#define FILE_MARK		0x10
#define SPACE			0x11
#define INQUIRY 		0x12
#define ERASE			0x19

#define SPACE_BLOCKS 	0
#define SPACE_MARKS		1

typedef struct							/* SCSI command structure */
{
	unsigned char opCode;
	unsigned char byte1;
	unsigned char byte2;
	unsigned char byte3;
	unsigned char byte4;
	unsigned char controlByte;
} SCSI_Command;

/* General stuff */

#ifndef OK
#define OK 0
#endif
#ifndef ERROR
#define ERROR 1
#endif
#ifndef NIL
#define NIL 0L
#endif