/* Prototypes.h */

/* scsi.c */

short FindTape(char *name, short *id);								/* finds a SCSI tape device and returns an 8 character string */

/* high level */

short Select(short lun);											/* Select SCSI ID */
short Sense(void);													/* do a SCSI sense */
short WriteBlock(void *ptr);										/* write a block to tape */
short ReadBlock(void *ptr);											/* read a block to tape */
short Rewind(void);													/* rewind tape */
short Inquiry(void *ptr, unsigned char nBytes);						/* perform an inquiry command */
short UnitReady(void);												/* test if device ready */
short WriteBlocks(void *ptr, unsigned short blocks);				/* write a number of blocks */ 
short WriteMark(unsigned short number);								/* write filemarks */
short ReadBlocks(void *ptr, unsigned short blocks);					/* write a number of blocks */
short Space(short number, unsigned char type);						/* space over blocks or filemarks */
short Erase(unsigned char restFlag);								/* erase - to rest of tape if flag set */

/* low level */

void Write(long blockSize, long numBlocks, void *bufferPtr);		/* Write SCSI data */
void Read(long blockSize, long numBlocks, void *bufferPtr);			/* Read SCSI data */
void Command(unsigned char opCode, unsigned char byte1,				/* do SCSI command */
	 unsigned char byte2, unsigned char byte3, unsigned char byte4, 
	 unsigned char controlByte);
short Complete(long ticks);											/* Complete SCSI command */
